-module('FOO').

-export([c/1]).

%% Xref!
-define(T_ATOM, 1).
-define(T_PORT, 2).
-define(T_INT, 3).
-define(T_TUPLE, 4).

c(B) ->
    c(B, []).

c(<<>>, []) ->
    throw(icky_i_think);
c(<<>>, [T]) ->
    T;
c(<<?T_ATOM:8, Len:8, Rest/binary>>, S) ->
    <<A:Len/binary, Rest2/binary>> = Rest,
    c(Rest2, [list_to_atom(binary_to_list(A))|S]);
c(<<?T_PORT:8, P:32, Rest/binary>>, S) ->
    c(Rest, [{port_thingie, P}|S]);
c(<<?T_INT:8, I:32, Rest/binary>>, S) ->
    c(Rest, [I|S]);
c(<<?T_TUPLE:8, N:8, Rest/binary>>, S) ->
    {L, NS} = popN(N, S),
    c(Rest, [list_to_tuple(L)|NS]);
c(X, Y) ->
    throw({bah, X, Y}).

popN(N, S) ->
    popN(N, S, []).
popN(0, S, Acc) ->
    {Acc, S};
popN(N, [H|T], Acc) ->
    popN(N - 1, T, [H|Acc]).
